package com.example.customtoolsample;

import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.ImageView;

import androidx.annotation.IdRes;
import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.fragment.app.FragmentActivity;
import com.pdftron.pdf.config.ToolManagerBuilder;
import com.pdftron.pdf.config.ViewerBuilder2;
import com.pdftron.pdf.config.ViewerConfig;
import com.pdftron.pdf.controls.PdfViewCtrlTabHostFragment2;
import com.pdftron.pdf.model.FileInfo;
import java.io.File;


public class MainActivity extends AppCompatActivity implements PdfViewCtrlTabHostFragment2.TabHostListener {

    PdfViewCtrlTabHostFragment2 fr = null;
    PdfViewCtrlTabHostFragment2 mPdfViewCtrlTabHostFragment;
    ViewerConfig.Builder builder;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        File file = new File(getExternalFilesDir(Environment.DIRECTORY_DOWNLOADS).getPath() + "/output.pdf");
        addViewerFragment(R.id.myLayout, this, file);
    }

    // Add a viewer fragment to the layout container in the specified
    // activity, and returns the added fragment
    public void addViewerFragment(@IdRes int fragmentContainer, @NonNull FragmentActivity activity, @NonNull File fileUri) {

        ToolManagerBuilder toolManagerBuilder = ToolManagerBuilder.from();

        builder = new ViewerConfig.Builder();

        ViewerConfig config = builder.toolManagerBuilder(toolManagerBuilder).build();

        // Create the viewer fragment
        mPdfViewCtrlTabHostFragment =
                ViewerBuilder2.withFile(fileUri).usingConfig(config).build(activity);

        // Add the fragment to the layout fragment container
        activity.getSupportFragmentManager().beginTransaction()
                .replace(fragmentContainer, mPdfViewCtrlTabHostFragment).commit();

        mPdfViewCtrlTabHostFragment.addHostListener(this);

    }

    @Override
    public void onTabHostShown() {
        mPdfViewCtrlTabHostFragment.getCurrentPdfViewCtrlFragment().setSavingEnabled(false);
    }

    @Override
    public void onTabHostHidden() {

    }

    @Override
    public void onLastTabClosed() {

    }

    @Override
    public void onTabChanged(String tag) {
         mPdfViewCtrlTabHostFragment.getCurrentPdfViewCtrlFragment().setSavingEnabled(false);
    }

    @Override
    public boolean onOpenDocError() {
        return false;
    }

    @Override
    public void onNavButtonPressed() {

    }

    @Override
    public void onShowFileInFolder(String fileName, String filepath, int itemSource) {

    }

    @Override
    public boolean canShowFileInFolder() {
        return false;
    }

    @Override
    public boolean canShowFileCloseSnackbar() {
        return false;
    }

    @Override
    public boolean onToolbarCreateOptionsMenu(Menu menu, MenuInflater inflater) {
        return false;
    }

    @Override
    public boolean onToolbarPrepareOptionsMenu(Menu menu) {
        return false;
    }

    @Override
    public boolean onToolbarOptionsItemSelected(MenuItem item) {
        Log.e("id-->", String.valueOf(item.getItemId()));

        switch (String.valueOf(item.getItemId())) {

        }
        return false;
    }

    @Override
    public void onStartSearchMode() {

    }

    @Override
    public void onExitSearchMode() {

    }

    @Override
    public boolean canRecreateActivity() {
        return false;
    }

    @Override
    public void onTabPaused(FileInfo fileInfo, boolean isDocModifiedAfterOpening) {

    }

    @Override
    public void onJumpToSdCardFolder() {

    }

    @Override
    public void onTabDocumentLoaded(String tag) {
        mPdfViewCtrlTabHostFragment.getCurrentPdfViewCtrlFragment().getToolManager().enableAnnotManager("12345-67890-ABCD-EFGH", (action, xfdfCommand, xfdfJSON) -> {
        });
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
    }
}